package com.hanyun.hip.mrqc.jms;

import com.hanyun.hip.message.annotation.EnableHanyunMessage;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.jdbc.DataSourceAutoConfiguration;
import org.springframework.boot.builder.SpringApplicationBuilder;
import org.springframework.boot.web.servlet.support.SpringBootServletInitializer;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableAsync;


@Configuration
@SpringBootApplication(exclude = { DataSourceAutoConfiguration.class })
@ComponentScan(value = { "com.ruoyi.*", "com.hanyun.hip.mrqc.**", "com.hanyun.hip.sso.*", "com.hanyun.hip.kgms.*",
        "com.hanyun.kgms.*", "com.hanyun.hip.term.*", "com.hanyun.hip.license.*","com.hanyun.hip.knowledge.*",
        "com.hanyun.hip.drools.*","com.hanyun.hip.ai.*","com.hanyun.ai.*" })
@MapperScan(value = { "com.ruoyi.*.mapper", "com.hanyun.**.mapper" })
@EnableAsync
@EnableHanyunMessage
public class Wx9yMrqcApplication extends SpringBootServletInitializer {
    @Override
    protected SpringApplicationBuilder configure(SpringApplicationBuilder builder) {
        return builder.sources(Wx9yMrqcApplication.class);
    }

    public static void main(String[] args) {
        SpringApplication.run(Wx9yMrqcApplication.class, args);
    }
}

