package com.hanyun.hip.mrqc.jms.api;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.poi.excel.ExcelReader;
import cn.hutool.poi.excel.ExcelUtil;
import com.hanyun.hip.mrqc.service.entity.EmrContent;
import com.hanyun.hip.mrqc.service.mapper.IMrqcEmrContentMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;

import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.util.List;
import java.util.stream.Collectors;

/**
 * ------------------------------------------------------------------------<br>
 *
 * @描述: ExcelImportUtil
 * <br>---------------------------------------------
 * @时间: 2024/3/22
 * @版本: 1.0
 * @创建人: Yurl
 */
@Controller
@RequestMapping("/mrqc/jms/test")
public class ExcelImportTest {


    @Autowired
    private IMrqcEmrContentMapper mrqcEmrContentMapper;
    @GetMapping("/import/userInfo")
    public String importUserInfo() throws Exception {
        File file = new File("C:\\Users\\16979\\Downloads\\聂佳祥.xls");
        // 1.获取上传文件输入流
        InputStream inputStream = null;
        try {
            inputStream = new FileInputStream(file);
        } catch (Exception e) {
            e.printStackTrace();
        }
        // 2.应用HUtool ExcelUtil获取ExcelReader指定输入流和sheet
        ExcelReader excelReader = ExcelUtil.getReader(inputStream, "Sheet1");
        // 可以加上表头验证
        // 3.读取第二行到最后一行数据
        List<List<Object>> read = excelReader.read(1, excelReader.getRowCount());
        if (CollUtil.isNotEmpty(read)){
            List<EmrContent> collect = read.stream()
                    .filter(item-> item.size() > 3)
                    .map(item -> {
                        EmrContent var1 = new EmrContent();
                        var1.setContentId(StrUtil.toString(item.get(0)));
                        var1.setContentText(null);
                        var1.setContentXml(StrUtil.toString(item.get(2)));
                        var1.setStructJson(StrUtil.toString(item.get(3)));
                        return var1;
                    }).collect(Collectors.toList());

            for (EmrContent emrContent : collect) {
                mrqcEmrContentMapper.insertOrUpdateEmrContentDoc(emrContent);
            }
        }

        return read.size() + "条";
    }
}
