package com.hanyun.hip.mrqc.jms.api;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.hanyun.hip.mrqc.jms.constants.JmsConstant;
import com.hanyun.hip.mrqc.jms.entity.MrqcEmrConfig;
import com.hanyun.hip.mrqc.jms.service.IMrqcEmrConfigService;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.framework.util.ShiroUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

;

/**
 * 通大分配规则数据控制层
 */
@Controller
@RequestMapping("/jms/manageRecord")
public class TdfyManageRecordController extends BaseController {
    public static final Logger LOGGER = LoggerFactory.getLogger(TdfyManageRecordController.class);

    @Autowired
    private IMrqcEmrConfigService mrqcEmrConfigService;

    @RequestMapping(value = "/saveDistributeRule", method = RequestMethod.POST)
    @ResponseBody
    public AjaxResult saveDistributeRule(@RequestBody JSONObject jsonObject) {
        AjaxResult ret;
        try {
            MrqcEmrConfig mrqcEmrConfig = new MrqcEmrConfig();
            jsonObject.keySet().forEach(key -> {
                mrqcEmrConfig.setConfigKey(key);
                if(key.equals(JmsConstant.EMRS_PERDAY)){
                    mrqcEmrConfig.setConfigValue(jsonObject.getString(key));
                    mrqcEmrConfig.setCreateTime(DateUtils.getNowDate());
                    mrqcEmrConfig.setUpdateTime(DateUtils.getNowDate());
                    mrqcEmrConfig.setCreateBy(ShiroUtils.getLoginName());
                }else if(key.equals(JmsConstant.EMS)){
                    JSONArray value=jsonObject.getJSONArray(key);
                    mrqcEmrConfig.setConfigValue(value.toJSONString());
                    mrqcEmrConfig.setCreateTime(DateUtils.getNowDate());
                    mrqcEmrConfig.setUpdateTime(DateUtils.getNowDate());
                    mrqcEmrConfig.setCreateBy(ShiroUtils.getLoginName());
                }
                MrqcEmrConfig mrqcEmrConfigTemp =mrqcEmrConfigService.selectMrqcEmrConfigByKey(key);
                if(mrqcEmrConfigTemp!=null){
                    mrqcEmrConfigService.deleteMrqcEmrConfigByIds(mrqcEmrConfigTemp.getConfigId().toString());
                }
                mrqcEmrConfigService.insertMrqcEmrConfig(mrqcEmrConfig);
            });
            ret = AjaxResult.success();
        } catch (Exception e) {
            logger.error("保存分配规则异常", e);
            ret = AjaxResult.error("保存分配规则异常，" + e);
        }
        return ret;
    }
}
