package com.hanyun.hip.mrqc.jms.service.impl;

import com.hanyun.hip.mrqc.jms.entity.ProcessDTO;
import com.hanyun.hip.mrqc.jms.entity.ProcessYWKDTO;
import com.hanyun.hip.mrqc.jms.service.IMrqcEmrConfigService;
import com.hanyun.hip.mrqc.service.entity.MrqcProcess;
import com.hanyun.hip.mrqc.service.service.MrqcAsyncExportService;
import com.ruoyi.framework.util.ShiroUtils;
import com.ruoyi.system.domain.SysRole;
import com.ruoyi.system.domain.SysUser;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @ClassName：ProcessListExport
 * @author: ouyang0810@foxmail.com
 * @CreateDate: 2024/11/1
 * @UpdateUser: ouyang0810@foxmail.com
 * @UpdateDate: 2024/11/1
 * @UpdateRemark:
 * @Description:
 * @Version: [V1.0]
 */
@Service("MrqcAsyncExportService")
public class ProcessListExportService implements MrqcAsyncExportService<MrqcProcess> {
    Logger logger = LogManager.getLogger(ProcessListExportService.class);

    @Autowired
    private IMrqcEmrConfigService iMrqcEmrConfigService;

    @Override
    public List<?> export(MrqcProcess mrqcProcess) {
        SysUser sysUser = ShiroUtils.getSysUser();
        List<SysRole> roles = sysUser.getRoles();
        boolean anyMatch = roles.stream().anyMatch(o -> "ywkdc".equals(o.getRoleKey()));
        if (anyMatch){
            List<ProcessYWKDTO> processList = iMrqcEmrConfigService.getProcessListByYWK(mrqcProcess);
            return processList;
        }else {

            List<ProcessDTO> processList = iMrqcEmrConfigService.getProcessList(mrqcProcess);
            return processList;
        }
    }
}
