package com.hanyun.hip.mrqc.jms.service.impl.extract;

import com.hankcs.hanlp.HanLP;
import com.hankcs.hanlp.seg.common.Term;
import com.hanyun.hip.mrqc.rule.entity.fact.MrqcStructData;
import com.hanyun.hip.mrqc.service.entity.EmrContent;
import com.hanyun.hip.mrqc.service.entity.MrqcStructExtract;
import com.hanyun.hip.mrqc.service.service.CustomStructExtracter;
import com.hanyun.hip.mrqc.service.util.UUidUtil;
import com.ruoyi.common.utils.StringUtils;
import org.dom4j.Document;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;

import java.io.StringReader;
import java.util.List;

public class XmlLastIndexStringExtracter implements CustomStructExtracter {
	
	final static String replaceChar1 = "/ ";
	final static String replaceChar2 = " /";
	
	@Override
	public MrqcStructData extract(MrqcStructExtract struct, EmrContent content, MrqcStructData parent) {
		try {
			parent = parent == null ? new MrqcStructData() : parent;
			String extScript = struct.getExtScript();
			
			String value = null;
			if(StringUtils.isNotEmpty(extScript)) {
	            //如xml不存在,从html提取
	            String contentXml = StringUtils.isNotBlank(content.getContentXml()) ? content.getContentXml() : content.getContentText();
	            if(StringUtils.isNotEmpty(contentXml)) {
		    		SAXReader reader = new SAXReader();
		    		StringReader sr = new StringReader(contentXml);
		    		Document document = reader.read(sr);
		            
		    		// 3.获取根节点
		    		Element rootElement = document.getRootElement();
		    		
		    		String text = rootElement.getText();
		    		
		    		if(text.contains(replaceChar1)) {
		    			text = text.replace(replaceChar1, "/");
		    		}
		    		if(text.contains(replaceChar2)) {
		    			
		    			String strLastString = StringUtils.substringBeforeLast(text, replaceChar2);
		    			
		    			String[] spiltSignText = strLastString.split("\\s");
		    			String strSign=spiltSignText[spiltSignText.length-1];
		    			List<Term> termList = HanLP.segment(strSign);
		    			
		    			if(termList.size()<3 ) {
		    				text = text.replace(replaceChar2, "/");
		    			}
		    		}
		            
		    		String[] spiltText = text.split(extScript);
		    		value=spiltText[spiltText.length-1];
		    		
	            }
			}
            
            if (parent.getDataId() == null) {
                parent.setDataId(UUidUtil.getUUID());
            }
			parent.setDataValue(value == null ? "" : String.valueOf(value));
			parent.setContentId(content.getContentId());
			parent.setRecordId(content.getRecordId());
			parent.setStructId(struct.getStructId());
		} catch (Exception e) {
			e.printStackTrace();
		}
		return parent;
	}

}
