package com.hanyun.hip.mrqc.jms.uitls;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.URL;

import cn.easyes.common.utils.StringUtils;

/**
 * @author zgp
 * @version V1.0
 * @Title: 
 * @Package 
 * @Description: 电子病历文书接口
 * @date 2022年11月15日 上午15:12:04
 */
public class WsdlToSoapUtil {

	public WsdlToSoapUtil() {
		// TODO Auto-generated constructor stub
	}
	
	public static String sendData(String urlString,String soapActionString,String xml) {
		
		StringBuffer sbXml = new StringBuffer();
		try {
			
			
	        URL url = new URL(urlString);
	        HttpURLConnection httpConn = (HttpURLConnection) url.openConnection();
	 
	        //Content-Length长度会自动进行计算
	        httpConn.setRequestProperty("Content-Type", "text/xml; charset=utf-8");
	        if(StringUtils.isNotEmpty(soapActionString)) {
	        	httpConn.setRequestProperty("soapActionString",soapActionString);//Soap1.1使用 其实完全可以不需要
	        }
	        httpConn.setRequestMethod("POST");
	        httpConn.setDoOutput(true);
	        httpConn.setDoInput(true);
	        
            OutputStream out = httpConn.getOutputStream();
            
            out.write(xml.getBytes());
            out.close();
            
            if (httpConn.getResponseCode() == HttpURLConnection.HTTP_OK)
            {
                InputStreamReader is = new InputStreamReader(httpConn.getInputStream());
                BufferedReader in = new BufferedReader(is);
                String inputLine;
                while ((inputLine = in.readLine()) != null)
                {
                	sbXml.append(inputLine);
                }
                in.close();
            }
            else{
                //如果服务器返回的HTTP状态不是HTTP_OK，则表示发生了错误，此时可以通过如下方法了解错误原因。
                InputStream is = httpConn.getErrorStream();    //通过getErrorStream了解错误的详情，因为错误详情也以XML格式返回，因此也可以用JDOM来获取。
                InputStreamReader isr = new InputStreamReader(is,"utf-8");
                BufferedReader in = new BufferedReader(isr);
                String inputLine;
                while ((inputLine = in.readLine()) != null)
                {
                    System.out.println(inputLine);
                }
                in.close();
            }
            httpConn.disconnect();
			
			
		}catch(Exception e) {
			e.printStackTrace();
		}
		
		return sbXml.toString();
	}
	
	public static void main(String srg[]) {
		
	}

}
