import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.NumberUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.ReflectUtil;
import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.setting.Setting;
import com.alibaba.druid.pool.DruidDataSource;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.hanyun.hip.license.common.util.EncryptUtil;
import com.hanyun.hip.license.verify.listener.LicenseCheckListener;
import com.hanyun.hip.mrqc.rule.entity.ExcResult;
import com.hanyun.hip.mrqc.rule.entity.fact.MrqcStructData;
import com.hanyun.hip.mrqc.rule.util.EngrUtil;
import com.hanyun.hip.mrqc.service.engine.rule.QcUtil;
import com.hanyun.hip.mrqc.service.entity.EmrContent;
import com.hanyun.hip.mrqc.service.entity.MrqcStruct;
import com.hanyun.hip.mrqc.service.service.impl.extract.XpathStructExtracter;
import com.hanyun.hip.mrqc.service.util.DateConverterUtil;
import com.hanyun.hip.mrqc.service.util.JsonUtil;
import com.hanyun.hip.mrqc.service.util.XpathUtil;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.collections.MapUtils;
import org.apache.commons.lang.StringUtils;
import org.drools.core.base.DefaultKnowledgeHelper;
import org.drools.core.spi.KnowledgeHelper;
import org.springframework.jdbc.core.BatchPreparedStatementSetter;
import org.springframework.jdbc.core.JdbcTemplate;

import javax.validation.constraints.NotNull;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class TestScript {

    static List<Map<String, Object>> mapList;
    static JdbcTemplate zxJdbcTemplate = getJdbcTemplate();

    public static void test(MrqcStructData $data, Map<String, Map<String, MrqcStructData>> $ctxDataMap, HashMap $map, ExcResult $result, String $recordId, Boolean $isProcessQc, KnowledgeHelper hEngr) throws Exception {

        $map = getStructData($recordId);
        DateConverterUtil dateConverterUtil = new DateConverterUtil();
        String rjbl = ((MrqcStructData) $map.get("HDSD00_11_157")).getDataValue();
        if(!EngrUtil.isNone(rjbl) && rjbl.equals("是")){
            return;
        }
        String ssrq = $data.getDataValue();
String datetime = "2024年10月29日13时20分/n";
        datetime.replace("/n", "");
        System.out.println(datetime);

        if (!StringUtils.isBlank(ssrq)) {
            ssrq = ssrq.replace("]", "").replace("[", "").replace(", ", ",");
            String yzcyTimeArray[] = ssrq.split(",");
            if (yzcyTimeArray != null && yzcyTimeArray.length > 0) {
                ssrq = yzcyTimeArray[0];
            }
        }
        String now = DateUtil.now();
        if (!StringUtils.isBlank(ssrq)) {
            if(ssrq.contains("～")){
                String ssrqArr[] = ssrq.split("～");
                ssrq = ssrqArr[1].trim();
            }
            SimpleDateFormat inputFormat = new SimpleDateFormat("yyyy年MM月dd日HH时mm分");
            SimpleDateFormat outputFormat = new SimpleDateFormat("yyyy-MM-dd");
            Date date = inputFormat.parse(ssrq);
            String formattedDate = outputFormat.format(date);
            Date dateTime = outputFormat.parse(formattedDate);

            DateTime offsetDayBegin = DateUtil.offsetDay(dateTime, 1);
            DateTime offsetDayEnd = DateUtil.offsetDay(dateTime, 2);
            DateTime nowDate = DateUtil.parse(now, "yyyy-MM-dd HH:mm:ss");
            //增加系统时间判断
            // if (nowDate.after(offsetDayBegin)) {
            //     JSONArray array = JSON.parseArray(JSON.toJSONString($contentList));
            //     List<JSONObject> dieList = new ArrayList<>();
            //     String contentTime = "";
            //     for (Object content : array) {
            //         JSONObject jsonObj = (JSONObject) content;
            //
            //         long ssrqTime = dateTime.getTime();
            //         String contentTimeStr = jsonObj.getString("contentTime");
            //
            //         String title = jsonObj.getString("title");
            //         boolean b = (title.contains("术后第一天") || title.contains("查房记录") || title.contains("日常病程记录")  ) && ssrqTime < Long.valueOf(contentTimeStr);
            //         if (b) {
            //             contentTime = jsonObj.getString("contentTime");
            //             dieList.add(jsonObj);
            //             break;
            //         }
            //     }
            //     if (CollectionUtils.isEmpty(dieList)) {
            //         $result.setRuleResult(hEngr, "术后24h内书写术后第一天病程记录");
            //         return;
            //     }
            //     if (StringUtils.isNotEmpty(contentTime)) {
            //         if (Long.parseLong(contentTime) > offsetDayEnd.getTime()) {
            //             $result.setRuleResult(hEngr, "术后24h内书写术后第一天病程记录");
            //         }
            //     }
            // }
        }






    }

    private static Map<String, Map<String, MrqcStructData>> getCtxDataMap(String $recordId) {
        Map<String, Map<String, MrqcStructData>> ctxDataMap = new HashMap<>();
        if (CollUtil.isEmpty(mapList)) {
            String mrqcStrctSql = "select ms.struct_code structId, mst.data_value dataValue,mst.content_id contentId  from mrqc_struct ms,mrqc_struct_data mst where ms.struct_id = mst.struct_id and  mst.record_id = '" + $recordId + "'";
            mapList = zxJdbcTemplate.queryForList(mrqcStrctSql);
        }
        for (Map<String, Object> stmap : mapList) {
            MrqcStructData data = BeanUtil.mapToBean(stmap, MrqcStructData.class, true);

            //处理不同文书有相同结构体的情况，设置全局文书结构体map
            String contentId = data.getContentId();
            if (StringUtils.isNotBlank(contentId)) {
                Map<String, MrqcStructData> cdm = ctxDataMap.get(contentId);
                cdm = MapUtils.isEmpty(cdm) ? new HashMap<>() : cdm;
                cdm.put(data.getStructId(), data);
                ctxDataMap.put(contentId, cdm);
            }
        }
        return ctxDataMap;

    }

    public static double textSimilarityByMinStr(String strA, String strB) {
        if (StringUtils.isBlank(strA) && StringUtils.isBlank(strB)) {
            return 0.0d;
        }

        int temp = Math.min(strA.length(), strB.length());
        int temp2 = getLongestCommonSubstring(strA, strB).length();
        return NumberUtil.div((float) temp2, (float) temp);

    }

    public static String getLongestCommonSubstring(String strA, String strB) {

        if (StringUtils.isBlank(strA) && StringUtils.isBlank(strB)) return "";
        char[] chars_strA = strA.toCharArray();
        char[] chars_strB = strB.toCharArray();
        int m = chars_strA.length;
        int n = chars_strB.length;
        int[][] matrix = new int[m + 1][n + 1];

        int currentIndex;
        for (int i = 1; i <= m; ++ i) {
            for (currentIndex = 1; currentIndex <= n; ++ currentIndex) {
                if (chars_strA[i - 1] == chars_strB[currentIndex - 1]) {
                    matrix[i][currentIndex] = matrix[i - 1][currentIndex - 1] + 1;
                } else {
                    matrix[i][currentIndex] = Math.max(matrix[i][currentIndex - 1], matrix[i - 1][currentIndex]);
                }
            }
        }

        char[] result = new char[matrix[m][n]];
        currentIndex = result.length - 1;

        while (matrix[m][n] != 0) {
            if (matrix[m][n] == matrix[m][n - 1]) {
                -- n;
            } else if (matrix[m][n] == matrix[m - 1][n]) {
                -- m;
            } else {
                result[currentIndex] = chars_strA[m - 1];
                -- currentIndex;
                -- n;
                -- m;
            }
        }

        return new String(result);
    }

    private static <T> T getObjectForClass(String sql, Class<T> tClass) {
        Map<String, Object> map = zxJdbcTemplate.queryForMap(sql);
        return BeanUtil.fillBeanWithMap(map, ReflectUtil.newInstance(tClass), true, true);
    }

    private static HashMap getStructData(String $recordId) {
        HashMap map = new HashMap();
        String mrqcStrctSql = "select ms.struct_code structId, mst.data_value dataValue,mst.content_id contentId   from mrqc_struct ms,mrqc_struct_data mst where ms.struct_id = mst.struct_id and  mst.record_id = '" + $recordId + "'";
        mapList = zxJdbcTemplate.queryForList(mrqcStrctSql);

        if (CollUtil.isNotEmpty(mapList)) {
            for (Map<String, Object> stringObjectMap : mapList) {
                MrqcStructData mrqcStructData = BeanUtil.mapToBean(stringObjectMap, MrqcStructData.class, true);
                map.put(mrqcStructData.getStructId(), mrqcStructData);
            }
        }
        System.out.println();
        return map;
    }


    public static void main(String[] args) throws Exception {

        String datetime = "2024年10月29日13时20分/n";
        datetime = datetime.replace("/n", "");
        System.out.println(datetime);

        // MrqcStructData $data = new MrqcStructData();
        // $data.setContentId("1001J6100000008A763L");
        // HashMap $map = new HashMap();
        // HashMap $ctxMap = new HashMap();
        // ExcResult $result = new ExcResult();
        // String $recordId = "1418256";
        // Boolean $isProcessQc = false;
        // KnowledgeHelper hEngr = new DefaultKnowledgeHelper<>();
        // test($data, $ctxMap, $map, $result, $recordId, $isProcessQc, hEngr);


    }

    private void testA(boolean a) {
        a = true;
    }


    private static List<Map<String, Object>> getResultForList(String sql) {
        List<Map<String, Object>> mapList = zxJdbcTemplate.queryForList(sql);
        return mapList;
    }

    private static void updateResultForList(List<Map<String, Object>> list) {

        String sql = "UPDATE mrqc_pub_rule SET rule_script = ? WHERE rule_id = ?";

        zxJdbcTemplate.batchUpdate(sql, new BatchPreparedStatementSetter() {
            @Override
            public void setValues(PreparedStatement ps, int i) throws SQLException {
                Map<String, Object> map = list.get(i);
                ps.setString(1, (String) map.get("rule_script"));           // 假设id是主键
                ps.setString(2, (String) map.get("rule_id")); // 假设columnName是要更新的字段
            }

            @Override
            public int getBatchSize() {
                return list.size();
            }
        });
    }


    private static Map<String, Object> getResultForMap(String sql) {
        Map<String, Object> map = zxJdbcTemplate.queryForMap(sql);
        return map;
    }

    @NotNull
    private static JdbcTemplate getJdbcTemplate() {
        Setting poolSetting = new Setting();
        poolSetting.put("initialSize", "20");
        poolSetting.put("maxActive", "50");
        poolSetting.put("maxWait", "60000");
        poolSetting.put("validationQuery", "SELECT 1");
        JdbcTemplate zxJdbcTemplate = new JdbcTemplate();
//        zxJdbcTemplate.setDataSource(createDataSource("jdbc:mysql://192.168.1.14:3306/mrqc_glyy?useUnicode=true&characterEncoding=utf8&useSSL=true&allowMultiQueries=true&serverTimezone=GMT%2B8", "com.mysql.cj.jdbc.Driver", "root", "HanYun#2021", poolSetting));
//         zxJdbcTemplate.setDataSource(createDataSource("jdbc:mysql://192.168.1.18:3306/hip?useUnicode=true&characterEncoding=utf8&useSSL=true&allowMultiQueries=true&serverTimezone=GMT%2B8", "com.mysql.cj.jdbc.Driver", "root", "HanYun#2021", poolSetting));
        zxJdbcTemplate.setDataSource(createDataSource("jdbc:mysql://127.0.0.1:3306/mrqc_sy?useUnicode=true&characterEncoding=utf8&useSSL=true&allowMultiQueries=true&serverTimezone=GMT%2B8", "com.mysql.cj.jdbc.Driver", "root", "123456", poolSetting));
        return zxJdbcTemplate;
    }

    protected static DruidDataSource createDataSource(String jdbcUrl, String driver, String user, String pass, Setting poolSetting) {
        final DruidDataSource ds = new DruidDataSource();
        ds.setUrl(jdbcUrl);
        ds.setDriverClassName(driver);
        ds.setUsername(user);
        ds.setPassword(pass);

        // 规范化属性名
        Properties druidProps = new Properties();
        String keyStr;
        for (Map.Entry<String, String> entry : poolSetting.entrySet()) {
            keyStr = StrUtil.addPrefixIfNot(entry.getKey(), "druid.");
            druidProps.put(keyStr, entry.getValue());
        }
        // 连接池信息
        ds.configFromPropety(druidProps);

        // 检查关联配置，在用户未设置某项配置时，
        if (null == ds.getValidationQuery()) {
            // 在validationQuery未设置的情况下，以下三项设置都将无效
            ds.setTestOnBorrow(false);
            ds.setTestOnReturn(false);
            ds.setTestWhileIdle(false);
        }

        return ds;
    }

}
